import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import pvWinJ.*;

public class DemoRBut extends Applet
{
	pvWinJ.PVRoundButton butt[] = null;

	public String getAppletInfo()
	{ return "Name: DemoRBut\r\nAuthor: Viktor"; }

	public void init()
	{
		if(butt != null)
			return;
		setSize(560, 440);
		setBackground(Color.lightGray);
		setLayout(null);

		setLayout(null);
		//-----------------------------------------------
		// add buttons
		butt = new pvWinJ.PVRoundButton[50];

		butt[0] = new pvWinJ.PVRoundButton("Demo applet with PVRoundButton class.", 24);
		butt[0].setText3D(new Dimension(-2, -1));
		butt[0].setEnabled(false);
		butt[0].setColorsDepth(1);
		butt[0].setBackColor(new Color(0xffc0c000));
		add(butt[0]);
		butt[0].setBounds(50, 0, 220, 30);

		butt[1] = new pvWinJ.PVRoundButton("Buttons support 3-States,");
		add(butt[1]);
		butt[1].setColorsDepth(1);
		butt[1].setBounds(30, 40, 170, 35);

		butt[2] = new pvWinJ.PVRoundButton("can Keep Pressed State");
		add(butt[2]);
		butt[2].setBounds(200, 40, 170, 35);
		butt[2].setColorsDepth(1);
		butt[2].setCanKeepPressed(true);

		butt[3] = new pvWinJ.PVRoundButton("and painted by any color.", 12);
		add(butt[3]);
		butt[3].setColorsDepth(1);
		butt[3].setBounds(365, 40, 85, 25);

		butt[4] = new pvWinJ.PVRoundButton("White");
		add(butt[4]);
		butt[4].setFont(new Font("Courier",  Font.BOLD | Font.ITALIC, 14));
		butt[4].setBackColor(Color.white);
		butt[4].setText3DColor(Color.cyan);
		butt[4].setBounds(10, 70, 55, 25);

		butt[5] = new pvWinJ.PVRoundButton("Yellow", 12);
		add(butt[5]);
		butt[5].setBackColor(Color.yellow);
		butt[5].setBounds(70, 70, 55, 25);

		butt[6] = new pvWinJ.PVRoundButton("Red", 12);
		add(butt[6]);
		butt[6].setCanKeepPressed(true);
		butt[6].setFont(new Font("Courier",  Font.ITALIC, 12));
		butt[6].setBackColor(Color.red);
		butt[6].setBounds(130, 70, 55, 25);

		butt[7] = new pvWinJ.PVRoundButton("Green", 12);
		add(butt[7]);
		butt[7].setCanKeepPressed(true);
		butt[7].setBackColor(Color.green);
		butt[7].setBounds(190, 70, 55, 25);

		butt[8] = new pvWinJ.PVRoundButton("Purple", 12);
		add(butt[8]);
		butt[8].setCanKeepPressed(true);
		butt[8].setBackColor(new Color(0xffc000c0));
		butt[8].setBounds(250, 70, 55, 25);

		butt[9] = new pvWinJ.PVRoundButton("Pink", 12);
		add(butt[9]);
		butt[9].setCanKeepPressed(true);
		butt[9].setBackColor(Color.pink);
		butt[9].setBounds(310, 70, 55, 25);

		butt[10] = new pvWinJ.PVRoundButton("Cyan", 12);
		add(butt[10]);
		butt[10].setCanKeepPressed(true);
		butt[10].setBackColor(Color.cyan);
		butt[10].setBounds(370, 70, 55, 25);

		butt[11] = new pvWinJ.PVRoundButton("Orange", 12);
		add(butt[11]);
		butt[11].setCanKeepPressed(true);
		butt[11].setBackColor(Color.orange);
		butt[11].setBounds(430, 70, 55, 25);

		butt[12] = new pvWinJ.PVRoundButton("Brown", 12);
		add(butt[12]);
		butt[12].setCanKeepPressed(true);
		butt[12].setBackColor(new Color(0xffa06000));
		butt[12].setBounds(490, 70, 55, 25);

		butt[13] = new pvWinJ.PVRoundButton("Edges can be different types.", 14);
		add(butt[13]);
		butt[13].setColorsDepth(2);
		butt[13].setTextPressed("OK");
		butt[13].setAureole(true);
		butt[13].setBounds(2, 125, 170, 35);
		butt[13].setAutoResize(true);

		butt[14] = new pvWinJ.PVRoundButton("Shadow position can be switched on press.", 14);
		add(butt[14]);
		butt[14].setColorsDepth(2);
		butt[14].setTextPressed("OK");
		butt[14].setText3DColor(Color.black);
		butt[14].setForeground(Color.white);
		butt[14].setAureole(true);
		butt[14].setBounds(233, 125, 170, 35);
		butt[14].setAutoResize(true);

		int i;
		for(i=4; i < 6; i++)
		{
		}
		for(i=0; i < 9; i++)
		{
			if(i > 0)
				butt[i].setThreeButtonStates(true);
			if(i < 4)
				butt[i].setAutoResize(true);
			if(i > 6)
				butt[i].setExtraPoppedUp(true);
			if(i != 2 && i < 6)
				butt[i].setTextPressed("OK");
		}
		int ii;
		for(i=15; i < 21; i++)
		{
			butt[i] = new pvWinJ.PVRoundButton("");
			add(butt[i]);
			ii = i - 15;
			butt[i].setShape(ii);
			butt[i].setText("Shape " + ii);
			butt[i].setBounds(5 + ii * 64, 152, 60, 35);
		}
		butt[21] = new pvWinJ.PVRoundButton("Switch");
		add(butt[21]);
		butt[21].setCanKeepPressed(true);
		butt[21].setShadowColor(Color.blue);
		butt[21].setShadow(1);
		butt[21].setSwitchShadowOnPress(true);
		butt[21].setBounds(400, 152, 65, 40);
		
		butt[22] = new pvWinJ.PVRoundButton("Dont switch");
		add(butt[22]);
		butt[22].setShadowColor(Color.green);
		butt[22].setShadow(2);
		butt[22].setCanKeepPressed(true);
		butt[22].setBounds(468, 152, 90, 40);

		butt[23] = new pvWinJ.PVRoundButton("Size of Center Area " +
			"and Color's Depth can be changed.");
		add(butt[23]);
		butt[23].setFont(new Font("Courier", Font.BOLD, 16));
		butt[23].setExtraPoppedUp(true);
		butt[23].setBounds(0, 220, 170, 35);
		butt[23].setAutoResize(true);

		int left = 5;
		for(i=24; i < 34; i++)
		{
			butt[i] = new pvWinJ.PVRoundButton("");
			add(butt[i]);
			ii = i - 24;
			if(ii < 5) 
			{
				butt[i].setCenterArea(ii * 2);
				butt[i].setText("Size" + ii * 2);
			}
			else
			{
				butt[i].setColorsDepth(ii - 5);
				butt[i].setText("Depth" + (ii - 5));
				left = 10;
			}
			butt[i].setBounds(left + ii * 55, 250, 52, 40);
		}
		butt[34] = new pvWinJ.PVRoundButton("Examples with different settings");
		add(butt[34]);
		butt[34].setFont(new Font("Courier", Font.BOLD | Font.ITALIC, 20));
		butt[34].setExtraPoppedUp(true);
		butt[34].setColorsDepth(1);
//		butt[34].setBackColor(new Color(0xffc0c000));
		butt[34].setEnabled(false);
		butt[34].setBounds(80, 320, 170, 35);
		butt[34].setAutoResize(true);

		butt[35] = new pvWinJ.PVRoundButton("A", 16);
		add(butt[35]);
		butt[35].setText3D(new Dimension(1, 1));
		butt[35].setCenterArea(0);
		butt[35].setShape(5);
		butt[35].setBounds(5, 360, 20, 40);

		butt[36] = new pvWinJ.PVRoundButton("B", 16);
		add(butt[36]);
		butt[36].setText3D(new Dimension(1, 1));
		butt[36].setShape(5);
		butt[36].setBackColor(new Color(0xff40c080));
		butt[36].setBounds(30, 360, 20, 40);

		butt[37] = new pvWinJ.PVRoundButton("C", 16);
		add(butt[37]);
		butt[37].setText3D(new Dimension(0, -1));
		butt[37].setShadow(1);
		butt[37].setShadowWidth(15);
		butt[37].setShape(2);
		butt[37].setBackColor(new Color(0xffe06000));
		butt[37].setBounds(55, 360, 35, 55);

		butt[38] = new pvWinJ.PVRoundButton("D", 16);
		add(butt[38]);
		butt[38].setShadow(1);
		butt[38].setShadowWidth(15);
		butt[38].setText3D(new Dimension(1, 1));
		butt[38].setShape(5);
		butt[38].setBackColor(new Color(0xff60c0f0));
		butt[38].setBounds(95, 360, 55, 55);

		butt[39] = new pvWinJ.PVRoundButton("E", 24);
		add(butt[39]);
		butt[39].setText3DColor(Color.black);
		butt[39].setForeground(Color.white);
		butt[39].setAureole(true);
		butt[39].setSwitchColorsOnPress(true);
		butt[39].setShape(2);
		butt[39].setCenterArea(9);
		butt[39].setBackColor(new Color(0xff60e0ff));
		butt[39].setBounds(155, 360, 40, 40);

		butt[40] = new pvWinJ.PVRoundButton("F");
		add(butt[40]);
		butt[40].setShadowColor(new Color(0xffc06000));
		butt[40].setShadow(3);
		butt[40].setForeground(Color.white);
		butt[40].setSwitchShadowOnPress(true);
		butt[40].setBackColor(Color.blue);
		butt[40].setShadowWidth(7);
		butt[40].setText3D(new Dimension(0, 0));
		butt[40].setShape(1);
		butt[40].setColorsDepth(0);
		butt[40].setBounds(200, 360, 50, 25);

		butt[41] = new pvWinJ.PVRoundButton("G");
		add(butt[41]);
		butt[41].setShadow(4);
		butt[41].setSwitchColorsOnPress(true);
		butt[41].setBackColor(Color.cyan);
		butt[41].setShadowWidth(7);
		butt[41].setShape(1);
		butt[41].setColorsDepth(4);
		butt[41].setCenterArea(0);
		butt[41].setBounds(255, 360, 50, 25);

		butt[42] = new pvWinJ.PVRoundButton("AutoResized", 11);
		add(butt[42]);
		butt[42].setShadow(3);
		butt[42].setText3D(new Dimension(-1, 1));
		butt[42].setBackColor(Color.gray);
		butt[42].setText3DColor(Color.green);
		butt[42].setShape(2);
		butt[42].setBounds(200, 390, 50, 30);
		butt[42].setAutoResize(true);

		butt[43] = new pvWinJ.PVRoundButton("Press it to trigger ABCDEFG state", 13);
		add(butt[43]);
		butt[43].setShadow(1);
		butt[43].setBackColor(Color.gray);
		butt[43].setText3DColor(Color.green);
		butt[43].setShape(2);
		butt[43].setCenterArea(6);
		butt[43].setSwitchShadowOnPress(true);
		butt[43].setAureole(true);
		butt[43].setBounds(315, 360, 240, 55);
		butt[43].addActionListener(new ButtListener());

		for(i=35; i < 44; i++)
		{
			butt[i].setCanKeepPressed(true);
		}
	}
	//------------------------------------------
	// handle mouse events
	class ButtListener implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{ processButton(evt.getSource()); }
	}
	private void processButton(Object source)
	{
		if(source != butt[43])
			return;
		boolean bPressed = butt[43].getPressed();
		for(int i=35; i < 42; i++)
			butt[i].setPressed(bPressed);
	}
}
