import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import pvWinJ.*;

public class DemoSpin extends Applet
{
	pvWinJ.PVSpin spin[] = null;
	pvWinJ.PVNumeric num = null;
	
	String str[] = { "Anna", "Cathy", "James", "Mary", "Viktor" };

	int iColor = 0;
	int iList = 0;

	public String getAppletInfo()
	{ return "Name: DemoSpin\r\nAuthor: Viktor"; }

	public void init()
	{
		if(spin != null)
			return;
		setSize(580, 340);
		setLayout(null);
		setBackground(Color.lightGray);
		//---------------------------------
		// create PVSpin objects
		spin = new pvWinJ.PVSpin[13];
		for(int i=0; i < 13; i++)
			spin[i] = new pvWinJ.PVSpin(PVSpin.HORIZONTAL_CENTER);
		
		add(spin[0]);
		spin[0].setDelay(400);
		spin[0].setSpeedUp(false);
		spin[0].setBounds(10, 140, 30, 30);
		

		add(spin[1]);
		spin[1].setDelay(500);
		//---------------------------------
		// get spin buttons and set some properties
		pvWinJ.PVImageButton but[] = spin[1].getButtons();
		but[0].setThreeButtonStates(true);
		but[1].setThreeButtonStates(true);
		spin[1].setButtonColor(Color.red);
		spin[1].setBounds(130, 140, 40, 40);

		add(spin[2]);
		spin[2].setDelay(30);
		spin[2].setSpeedUp(false);
		spin[2].setStyle(PVSpin.VERTICAL_CENTER);
		but = spin[2].getButtons();
		but[0].setText("Up");
		but[1].setText("Down");
		but[0].setAureole(true);
		but[1].setAureole(true);
//		spin[2].setDefaultImages(false);
		spin[2].setButtonBorder(1);
		spin[2].setBounds(48, 140, 70, 35);

		add(spin[3]);
		spin[3].setGap(70);
		//---------------------------------
		// set object to pvWinJ.PVNumeric
		spin[3].setObject(new pvWinJ.PVNumeric(100.001));
		//---------------------------------
		// get PVObject and set some properties
		num = (pvWinJ.PVNumeric)spin[3].getObject();
		num.setDelta(100.001);
		spin[3].setBounds(310, 140, 110, 18);

		add(spin[4]);
		spin[4].setButtonColor(Color.green);
		spin[4].setGap(10);
		spin[4].setBounds(210, 140, 50, 40);

		add(spin[5]);
		spin[5].setGap(70);
		//---------------------------------
		// set object to PVDate
		spin[5].setObject(new pvWinJ.PVDate(new Date()));
		spin[5].setDefaultImages(false);
		spin[5].setButtonBorder(pvWinJ.PVButton.SIMPLE2);
		spin[5].setBounds(310, 162, 110, 18);

		add(spin[6]);
		spin[6].setSpeedUp(false);
		spin[6].setDelay(50);
		but = spin[6].getButtons();
		but[0].setFont(new Font("Arial", Font.BOLD, 14));
		but[1].setFont(new Font("Arial", Font.BOLD, 14));
		but[0].setText("-");
		but[1].setText("+");
		spin[6].setDefaultImages(false);
		spin[6].setGap(75);
		spin[6].setStyle(pvWinJ.PVSpin.HORIZONTAL_LEFT);
		//---------------------------------
		// set object to Canvas
		Canvas c = new Canvas();
		c.setBackground(Color.green);
		spin[6].setObject(c);
		spin[6].setBounds(440, 140, 120, 40);
		//---------------------------------
		// set object to PVEdit
		pvWinJ.PVEdit e = new pvWinJ.PVEdit(str[iList]);
		e.setBackColor(Color.orange);
		e.setText3D(new Dimension(-1, -1));
		e.setBorder(pvWinJ.PVEdit.PICTURE);
		e.setEditable(false);
		e.setAlignment(1);
		e.setBorderColor(Color.orange);
		e.setFont(new Font("Courier", Font.BOLD, 18));
		add(spin[7]);
		spin[7].setSpeedUp(false);
		spin[7].setButtonColor(Color.orange);
		spin[7].setGap(60);
		spin[7].setObject(e);
		spin[7].setStyle(pvWinJ.PVSpin.HORIZONTAL_TOP);
		spin[7].setBounds(10, 260, 100, 70);
		//---------------------------------
		// create pvWinJ.PVTime and set it as the object for PVSpin
		pvWinJ.PVTime t = new pvWinJ.PVTime();
		t.setBackColor(Color.lightGray);
		t.setForeground(Color.white);
		t.setBorderColor(Color.darkGray);
		t.setText3DColor(Color.black);
		t.setText3D(new Dimension(1, 1));
		t.setBorder(pvWinJ.PVEdit.PICTURE + 5);
		t.setFont(new Font("Courier", Font.BOLD, 16));
		spin[8].setObject(t);
		add(spin[8]);
		spin[8].setGap(55);
		spin[8].setButtonColor(Color.gray);
		spin[8].setStyle(PVSpin.HORIZONTAL_BOTTOM);
		spin[8].setBounds(120, 260, 135, 70);

		t = new pvWinJ.PVTime();
		t.setBackColor(Color.white);
		t.setBorderColor(new Color(0xff80c080));
		t.setTwelveHours(false);
		t.setFontStyle(pvWinJ.PVEdit.LED_BOLD);
		t.setText3D(new Dimension(-1, -1));
		t.setBorder(pvWinJ.PVEdit.OUTDENT + 3);
		t.setFont(new Font("Courier", Font.BOLD, 12));
		add(spin[9]);
		spin[9].setStyle(pvWinJ.PVSpin.HORIZONTAL_LEFT);
		spin[9].setGap(76);
		spin[9].setObject(t);
		spin[9].setButtonColor(new Color(0xff80c080));
		spin[9].setButtonBorder(2);
		spin[9].setBounds(265, 260, 140, 28);
		//---------------------------------
		// create PVDate and set it as the object for PVSpin
		pvWinJ.PVDate d = new pvWinJ.PVDate(new Date());
		d.setBackColor(Color.lightGray);
		d.setForeground(Color.white);
		d.setFontStyle(pvWinJ.PVEdit.LED_BOLD);
		d.setShowCentury(false);
		d.setBorderColor(Color.darkGray);
		d.setText3DColor(Color.black);
		d.setText3D(new Dimension(1, 1));
		d.setBorder(pvWinJ.PVEdit.RAISED);
		add(spin[10]);
		spin[10].setStyle(PVSpin.VERTICAL_RIGHT);
		spin[10].setGap(90);
		spin[10].setButtonBorder(pvWinJ.PVButton.SIMPLE1);
		spin[10].setObject(d);
		spin[10].setBounds(265, 303, 140, 26);
		//---------------------------------
		// create pvWinJ.PVNumeric and set it as the object for PVSpin
		num = new pvWinJ.PVNumeric(1234.5678);
		num.setBackColor(new Color(0xffc080ff));
		num.setText3D(new Dimension(-1, -1));
		num.setBorder(pvWinJ.PVEdit.PLANE + 7);
		num.setDelta(1.0001);
		num.setBorderColor(new Color(0xff8080f0));
		num.setFont(new Font("Courier", Font.BOLD | Font.ITALIC, 18));
		add(spin[11]);
		spin[11].setStyle(PVSpin.VERTICAL_CENTER);
		spin[11].setGap(50);
		spin[11].setButtonColor(new Color(0xffc080ff));
		spin[11].setButtonBorder(PVButton.STANDARD3);
		spin[11].setObject(num);
		spin[11].setBounds(415, 260, 140, 70);
		//---------------------------------
		// create stand alone pvWinJ.PVNumeric
		num = new pvWinJ.PVNumeric();
		add(num);
		num.setAlignment(1);
		num.setBounds(10, 184, 250, 20);
		//---------------------------------
		// create listeners to PVSpin events
		for(int i=0; i < 8; i++) if(i != 5) 
			spin[i].addPVSpinListener(new SpinListener());
	}
	//------------------------------------------
	// class that handles spin events
	class SpinListener implements pvWinJ.PVSpinListener
	{
		public void up(EventObject evt)
		{ processSpin(evt.getSource(), true); }
		public void down(EventObject evt)
		{ processSpin(evt.getSource(), false); }
	}
	//------------------------------------------
	// function that does something on spin events
	private void processSpin(Object pv, boolean up)
	{
		if(!(pv instanceof pvWinJ.PVSpin))
			return;
		//---------------------------------------
		// get id of spin[] that fires event
		int i = -1;
		while(++i < 8)
			if(pv == spin[i]) break;
		//---------------------------------------
		// note: since the rest of spin[] are set with PVObjects,
		// they are connected to spin events automatically
		switch(i)
		{
			case 0: case 1: case 2: case 4:
				if(up) num.increment();
				else   num.decrement();
				return;
			case 6:
				drawCanvas((Canvas)spin[i].getObject(), (up ? 10 : -10));
				return;
			case 7:
				//---------------------------------
				// circle through strings
				if(up) { if(++iList > 4) iList = 0; }
				else   { if(--iList < 0) iList = 4; }
				((pvWinJ.PVEdit)spin[i].getObject()).setText(str[iList]);
				return;
		}
	}

	private void drawCanvas(Canvas c, int inc)
	{
		iColor += inc;
		if(iColor > 400) iColor = 0;
		if(iColor < 0) iColor = 400;
		int clr = 200 - iColor;
		if(clr < 0) clr = -clr;
		clr += 55;
		Graphics g = c.getGraphics();
		g.setColor(new Color(clr, clr, clr));
		g.fillOval(0, 0, c.getSize().width - 1, c.getSize().height - 1);
	}
	public void paint(Graphics g)
	{
		g.setFont(new Font("Courier", Font.BOLD | Font.ITALIC, 28));
		String s = new String("Demo Applet with PVSpin class");
		g.setColor(Color.white);
		g.drawString(s, 29, 23);
		g.setColor(Color.black);
		g.drawString(s, 31, 26);
		g.setColor(Color.lightGray);
		g.drawString(s, 30, 24);
		g.setColor(Color.white);
		g.setFont(new Font("Arial", Font.BOLD, 12));
		s = "PVSpin is designed to generate action events while a button is pressed.";
		g.drawString(s, 80, 50);
		g.setColor(Color.black);
		g.drawString(s, 81, 51);
		g.setFont(new Font("Arial", 0, 13));
		s = "Any aspect of its appearance and layout (buttons & object) can be customized.";
		g.drawString(s, 10, 70);
		s = "Buttons can be separated by an empty gap or ";
		s += "that gap can be filled up by an object.";
		g.drawString(s, 10, 85);
		s = "The object can be any class derived from the Component.";
		g.drawString(s, 10, 100);
		s = "In this demo the classes from the pvWinJ package are used.";
		g.drawString(s, 10, 115);

		g.setFont(new Font("Courier", Font.BOLD, 12));
		s = "Slow    Fast    Speed Up   Default rate.";
		g.drawString(s, 10, 135);

		s = "Alignment: TOP       BOTTOM            LEFT / RIGHT             CENTER";
		g.drawString(s, 10, 255);

		g.setFont(new Font("Courier", Font.BOLD, 18));
		s = "Examples with various painting styles";
		g.drawString(s, 80, 235);
		g.setColor(Color.white);
		g.drawString(s, 79, 234);
		g.dispose();
	}
}
