import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import pvWinJ.*;

public class DemoDate extends Applet
{
	pvWinJ.PVDate date[] = null;
	Button        butt[] = null;
	public String getAppletInfo()
	{ return "Name: DemoTime\r\nAuthor: Viktor"; }
	public void init()
	{
		if(date != null) return;
		date = new pvWinJ.PVDate[12];
		butt = new Button[2];
		setSize(580, 370);
		setBackground(Color.lightGray);
		setLayout(null);
		//-----------------------------------
		// add buttons
		int i;
		for(i=0; i < 2; i++)
		{
			butt[i] = new Button("Use get/set" + 
				((i == 0) ? "Date()" : "Text()"));
			add(butt[i]);
			butt[i].addActionListener(new ActListener());
			butt[i].setBounds(80 + i * 260, 115, 120, 45);
		}
		//-----------------------------------
		// add dates
		date[0] = new pvWinJ.PVDate();
		date[0].setSelectionOnFocus(true);
		add(date[0]);
		date[0].setAlignment(1);
		date[0].setShowCentury(false);
		date[0].setText("10/25/79");
		date[0].setBounds(210, 115, 120, 20);
		date[0].addTextListener(new TxtListener());
		//-----------------------------------
		// sample with mouse/mouseMotion listeners
		date[0].addMouseListener(new MouseListener()
		{
			public void mouseExited(MouseEvent e)
			{ System.err.println("exit");}
			public void mouseEntered(MouseEvent e)
			{ System.err.println("enter");}
			public void mouseClicked(MouseEvent e)
			{ System.err.println("click");}
			public void mousePressed(MouseEvent e)
			{ System.err.println("press");}
			public void mouseReleased(MouseEvent e)
			{ System.err.println("release");}
		});
		date[0].addMouseMotionListener(new MouseMotionListener()
		{
			public void mouseMoved(MouseEvent e)
			{ System.err.println("move");}
			public void mouseDragged(MouseEvent e)
			{ System.err.println("drag");}
		});
		date[1] = new pvWinJ.PVDate();
		add(date[1]);
		date[1].setSelectionOnFocus(true);
		date[1].setText("02/22/2222");
		date[1].setAlignment(1);
		date[1].setBounds(210, 140, 120, 20);
		date[1].addTextListener(new TxtListener());

		date[2] = new pvWinJ.PVDate(new Date());
		date[2].setSelectionOnFocus(true);
		add(date[2]);
		date[2].setBounds(20, 195, 90, 20);

		date[3] = new pvWinJ.PVDate(new Date());
		date[3].setMonthFirst(false);
		add(date[3]);
		date[3].setAlignment(2);
		date[3].setSeparator('.');
		date[3].setBounds(20, 220, 90, 20);

		date[4] = new pvWinJ.PVDate(new Date());
		add(date[4]);
		date[4].setFontStyle(pvWinJ.PVEdit.FORMATTED1);
		date[4].setBorder(pvWinJ.PVEdit.SUNKEN + 4);
		date[4].setText3D(new Dimension(-1, -1));
		date[4].setFont(new Font("Courier", Font.BOLD, 24));
		date[4].setShadow(pvWinJ.PVEdit.RIGHT_BOTTOM);
		date[4].setOdometer(pvWinJ.PVEdit.ODOMETER_DARK);
		date[4].setBounds(140, 195, 192, 45);
//		date[4].setAutoResize(true);

		date[5] = new pvWinJ.PVDate(new Date());
		add(date[5]);
		date[5].setBorder(pvWinJ.PVEdit.PICTURE + 4);
//		date[5].setBackColor(Color.lightGray);
		date[5].setShadow(pvWinJ.PVEdit.RIGHT_BOTTOM);
		date[5].setOdometer(pvWinJ.PVEdit.ODOMETER);
//		date[5].setText3DColor(Color.white);
		date[5].setFontStyle(pvWinJ.PVEdit.LED_BOLD);
		date[5].setText3D(new Dimension(-1, -1));
		date[5].setBounds(360, 195, 180, 51);

		date[6] = new pvWinJ.PVDate(new Date());
		add(date[6]);
		date[6].setShowYear(false);
		date[6].setAlignment(1);
		date[6].setBorder(pvWinJ.PVEdit.RAISED + 9);
		date[6].setBackColor(Color.lightGray);
		date[6].setText3DColor(Color.white);
		date[6].setForeground(Color.blue);
		date[6].setFontStyle(pvWinJ.PVEdit.LED);
		date[6].setAureole(true);
		date[6].setBounds(10, 290, 160, 60);

		date[7] = new pvWinJ.PVDate(new Date());
		add(date[7]);
		date[7].setBorder(pvWinJ.PVEdit.PICTURE | 0x100);
		date[7].setBackColor(Color.green);
		date[7].setOdometer(pvWinJ.PVEdit.ODOMETER_DARK);
		date[7].setText3DColor(Color.white);
		date[7].setText3D(new Dimension(1, 1));
		date[7].setBorderColor(Color.orange);
		date[7].setForeground(new Color(0xff800000));
		date[7].setFont(new Font("Courier", Font.BOLD | Font.ITALIC, 16));
		date[7].setBounds(190, 290, 160, 60);

		date[8] = new pvWinJ.PVDate();
		date[8].setSelectionOnFocus(true);
		add(date[8]);
		date[8].setShowYear(false);
		date[8].setBorder(pvWinJ.PVEdit.RAISED + 4);
		date[8].setBackColor(Color.lightGray);
		date[8].setShadow(pvWinJ.PVEdit.LEFT_TOP);
		date[8].setShadowWidth(12);
		date[8].setShadowColor(new Color(0xff806000));
		date[8].setFont(new Font("Courier", Font.BOLD, 28));
		date[8].setText3DColor(Color.red);
		date[8].setForeground(Color.yellow);
		date[8].setAureole(true);
		date[8].setBounds(365, 290, 110, 60);

		for(i=9; i < 12; i++)
		{
			date[i] = new pvWinJ.PVDate();
			date[i].setSelectionOnFocus(true);
			add(date[i]);
			date[i].setShowCentury(false);
			date[i].setBorder(pvWinJ.PVEdit.NONE);
			date[i].setBackColor(getBackground());
			date[i].setLeadingZero(false);
			date[i].setText("2/23/88");
		}
		date[9].setBounds(490, 290, 80, 15);

		date[10].setFontStyle(pvWinJ.PVEdit.LED_BOLD);
		date[10].setBounds(490, 310, 80, 17);

		date[11].setMonthFirst(false);
		date[11].setForeground(Color.green);
		date[11].setFontStyle(pvWinJ.PVEdit.LED_BOLD);
		date[11].setBounds(485, 330, 100, 20);
	}

	public void paint(Graphics g)
	{
		g.setFont(new Font("Courier", Font.BOLD | Font.ITALIC, 28));
		String s = new String("Demo Applet with PVDate class");
		g.setColor(Color.white);
		g.drawString(s, 40, 23);
		g.setColor(Color.black);
		g.drawString(s, 42, 26);
		g.setColor(Color.lightGray);
		g.drawString(s, 41, 24);
		g.setColor(Color.white);
		g.setFont(new Font("Arial", Font.BOLD, 12));
		s = "PVDate is designed to display and edit a text string that represents date.";
		g.drawString(s, 80, 50);
		g.setColor(Color.black);
		g.drawString(s, 81, 51);
		s = "All aspects of date format can be customized ";
		s += "(day/month, century, leading zero, separator, etc.)";
		g.drawString(s, 10, 70);

		s = "Buttons or date change will update another PVDate";
		g.drawString(s, 110, 110);

		g.setFont(new Font("Courier", Font.BOLD, 18));
		s = "Examples with various painting styles";
		g.drawString(s, 80, 280);
	}
	//------------------------------------------
	// handle text change events
	class TxtListener implements TextListener
	{
		public void textValueChanged(TextEvent evt)
		{ processChange(evt.getSource()); }
	}
	private void processChange(Object source)
	{
		if(source == date[0])
			date[1].setDate(date[0].getDate());
		else if(source == date[1])
		{
			date[2].setDate(date[1].getDate());
			date[3].setDate(date[1].getDate());
			date[4].setDate(date[1].getDate());
		}
	}
	//------------------------------------------
	// handle button events
	class ActListener implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{ processButton(evt.getSource()); }
	}
	private void processButton(Object source)
	{
		if(source == butt[0])
			date[1].setDate(date[0].getDate());
		if(source == butt[1])
			date[1].setText(date[0].getText());
	}
}
