import java.applet.*;
import java.awt.*;
import java.awt.event.*;

import pvWinJ.*;

public class DemoEdit extends Applet
{
	pvWinJ.PVEdit edit[] = null;
	pvWinJ.PVEdit butt[] = null;
	pvWinJ.PVMask mask[] = null;
   //--------------------------------------------------------------------------
	public String getAppletInfo()
	{ return "Name: DemoEdit\r\nAuthor: Viktor"; }
   //--------------------------------------------------------------------------
	public void init()
	{
		if(edit != null) return;
		int i;
		setSize(580, 520);
		setBackground(Color.lightGray);
		setLayout(null);
		//-----------------------------------------------
		// add edit controls
		edit = new pvWinJ.PVEdit[8];

		edit[0] = new pvWinJ.PVEdit("PVEdit");
		edit[0].setOdometer(pvWinJ.PVEdit.ODOMETER);
		edit[0].setBorder(pvWinJ.PVEdit.PICTURE | 0x100);
		edit[0].setFontStyle(pvWinJ.PVEdit.FORMATTED1);
		edit[0].setFont(new Font("Arial", Font.BOLD, 54));
		edit[0].setText3D(new Dimension(2, 1));
		edit[0].setAlignment(2);
		edit[0].setShadow(pvWinJ.PVEdit.RIGHT_BOTTOM);
		edit[0].setShadowWidth(8);
		add(edit[0]);
		edit[0].setBounds(5, 140, 560, 110);
		edit[0].setAutoResize(true);
//		edit[0].setSize(getPreferredSize());
		edit[0].addTextListener(new TxtListener());

		edit[3] = new pvWinJ.PVEdit("Examples with various settings");
		edit[3].setBorder(pvWinJ.PVEdit.PLANE);
		edit[3].setShadow(pvWinJ.PVEdit.RIGHT_BOTTOM);
		edit[3].setShadowWidth(3);
		edit[3].setFont(new Font("Courier", Font.BOLD | Font.ITALIC, 26));
		edit[3].setText3D(new Dimension(1, 0));
		edit[3].setBackColor(Color.lightGray);
		edit[3].setAlignment(1);
		add(edit[3]);
		edit[3].setBounds(5, 375, 570, 31);

		edit[1] = new pvWinJ.PVEdit("PVEdit");
		edit[1].setSelectionOnFocus(true);
		add(edit[1]);
		edit[1].setBorder(pvWinJ.PVEdit.SUNKEN + 1);
		edit[1].setBounds(5, 412, 85, 20);
		edit[1].addTextListener(new TxtListener());

		edit[2] = new pvWinJ.PVEdit("Center");
		edit[2].setAlignment(1);
		edit[2].setBorder(pvWinJ.PVEdit.SUNKEN + 1);
		edit[2].setHighlightColor(Color.cyan);
		add(edit[2]);
		edit[2].setBounds(5, 442, 85, 20);
		edit[2].addTextListener(new TxtListener());

		edit[4] = new pvWinJ.PVEdit("LED Bold");
		edit[4].setText3D(new Dimension(-1, -1));
		edit[4].setBorder(pvWinJ.PVEdit.RAISED + 8);
		edit[4].setFontStyle(pvWinJ.PVEdit.LED_BOLD);
		edit[4].setBackColor(Color.gray);
		edit[4].setShadow(pvWinJ.PVEdit.RIGHT_BOTTOM);
		edit[4].setHighlightColor(Color.blue);
		edit[4].setText3DColor(Color.white);
		add(edit[4]);
		edit[4].setBounds(95, 410, 190, 60);

		edit[5] = new pvWinJ.PVEdit("Thin");
		edit[5].setBackColor(Color.black);
		edit[5].setBorder(pvWinJ.PVEdit.PLANE + 8);
		edit[5].setFontStyle(pvWinJ.PVEdit.LED);
		edit[5].setShadow(pvWinJ.PVEdit.LEFT_BOTTOM);
		edit[5].setBorderColor(Color.cyan);
		edit[5].setHighlightColor(Color.lightGray);
		edit[5].setForeground(Color.cyan);
		add(edit[5]);
		edit[5].setBounds(290, 410, 100, 60);

		edit[6] = new pvWinJ.PVEdit("Font with aureole");
		edit[6].setBackColor(new Color(0xffff80c0));
		edit[6].setBorder(pvWinJ.PVEdit.OUTDENT + 7);
		edit[6].setFont(new Font("Arial", Font.BOLD, 18));
		edit[6].setAureole(true);
		edit[6].setBorderColor(Color.blue);
		edit[6].setShadow(pvWinJ.PVEdit.LEFT_TOP);
		edit[6].setShadowWidth(9);
		edit[6].setShadowColor(new Color(0xff608000));
		add(edit[6]);
		edit[6].setBounds(395, 410, 180, 60);

		mask = new pvWinJ.PVMask[9];

		mask[0] = new pvWinJ.PVMask("Mask: (~#~#~#) ~#~#~#-~#~#~#~# Ext. ~#~#~#");
		mask[0].setBackColor(getBackground());
		mask[0].setBorder(pvWinJ.PVEdit.NONE);
		mask[0].setForeground(Color.red);
		mask[0].setText3DColor(Color.blue);
		mask[0].setHighlightColor(Color.green);
		mask[0].setText3D(new Dimension(1, 0));
		add(mask[0]);
		mask[0].setBounds(5, 290, 210, 18);

		mask[3] = new pvWinJ.PVMask("(###) ###-#### Ext. ###");
		mask[3].setSelectionOnFocus(true);
		add(mask[3]);
		mask[3].setBounds(5, 308, 210, 20);

		mask[4] = new pvWinJ.PVMask("(###) ###-#### Ext. ###");
		mask[4].setForeground(Color.lightGray);
		mask[4].setBorder(pvWinJ.PVEdit.SUNKEN + 4);
		mask[4].setFont(new Font("Arial", Font.BOLD, 16));
		mask[4].setText3DColor(Color.black);
		mask[4].setOdometer(pvWinJ.PVEdit.ODOMETER_LIGHT + 1);
		mask[4].setHighlightColor(Color.green);
		mask[4].setText3D(new Dimension(1, 1));
		add(mask[4]);
		mask[4].setBounds(5, 330, 210, 30);

		mask[1] = new pvWinJ.PVMask("Mask: \"Name: ~@~@~@~@~@~@~@\"");
		mask[1].setBorder(pvWinJ.PVEdit.NONE);
		mask[1].setBackColor(getBackground());
		mask[1].setForeground(Color.red);
		mask[1].setText3DColor(Color.white);
		mask[1].setText3D(new Dimension(1, 0));
		add(mask[1]);
		mask[1].setBounds(225, 290, 180, 18);

		mask[5] = new pvWinJ.PVMask("Name: @@@@@@@");
		mask[5].setCase(2);
		mask[5].setInsertEditMode(true);
		add(mask[5]);
		mask[5].setBounds(225, 308, 180, 20);

		mask[6] = new pvWinJ.PVMask("Name: @@@@@@@");
		mask[6].setCase(1);
		mask[6].setBorder(pvWinJ.PVEdit.RAISED + 4);
		mask[6].setSelectionOnFocus(true);
		mask[6].setAureole(true);
		mask[6].setFont(new Font("Arial", Font.BOLD, 19));
		mask[6].setForeground(Color.pink);
		mask[6].setText3DColor(Color.black);
		mask[6].setHighlightColor(Color.red);
		add(mask[6]);
		mask[6].setBounds(225, 330, 180, 30);

		mask[2] = new pvWinJ.PVMask("Mask: ~~#~#~#~#~~@~@~@~@~~*~*~*~*");
		mask[2].setBorder(pvWinJ.PVEdit.NONE);
		mask[2].setBackColor(getBackground());
		add(mask[2]);
		mask[2].setBounds(413, 290, 160, 18);

		mask[7] = new pvWinJ.PVMask("~####~@@@@~****");
		add(mask[7]);
		mask[7].setBounds(413, 308, 160, 20);

		mask[8] = new pvWinJ.PVMask("~####~@@@@~****");
		mask[8].setFont(new Font("Courier", Font.BOLD, 18));
		mask[8].setBorder(pvWinJ.PVEdit.OUTDENT + 4);
		mask[8].setOdometer(pvWinJ.PVEdit.ODOMETER_DARK);
		mask[8].setText3DColor(Color.white);
		mask[8].setText3D(new Dimension(-1, 0));
		add(mask[8]);
		mask[8].setBounds(413, 330, 160, 30);

		for(i=3; i < 9; i++)
		{
			mask[i].addTextListener(new TxtListener());
		}

		//-----------------------------------------------
		// add labels
		pvWinJ.PVEdit label[] = new pvWinJ.PVEdit[7];
		label[0] = new pvWinJ.PVEdit("Demo Applet with PVEdit & PVMask classes");
		label[0].setBounds(0, 0, 580, 24);

		label[1] = new pvWinJ.PVEdit("Click \"Buttons\" to change PVEdit properties:");
		label[1].setBounds(35, 30, 520, 20);

		label[2] = new pvWinJ.PVEdit("All components in this Applet are PVEdit & PVMask classes");
		label[2].setBounds(5, 476, 570, 18);

		label[3] = new pvWinJ.PVEdit("Examples with PVMask: (#-digit; @-letter; *-anything)");
		label[3].setBounds(5, 268, 550, 20);
		label[3].setShadow(pvWinJ.PVEdit.LEFT_TOP);
		label[3].setAlignment(1);
		label[3].setShadowWidth(3);

		label[4] = new pvWinJ.PVEdit("Border");
		label[4].setBounds(80, 50, 100, 20);

		label[5] = new pvWinJ.PVEdit("Font");
		label[5].setBounds(235, 50, 100, 20);

		label[6] = new pvWinJ.PVEdit("Other");
		label[6].setBounds(390, 50, 100, 20);

		int iBuf;
		for(i=0; i < 7; i++)
		{
			label[i].setBorder(pvWinJ.PVEdit.NONE);
			label[i].setBackColor(getBackground());
			label[i].setText3DColor(Color.white);
			iBuf = 24 - i * 4;
			if(iBuf < 16) iBuf = 16;
			label[i].setFont(new Font("Courier", Font.BOLD, iBuf));
			iBuf = (i < 4) ? -1 : 1;
			label[i].setText3D(new Dimension(iBuf, iBuf));
			label[i].setEditable(false);
			add(label[i]);
		}
		//-----------------------------------------------
		// add "buttons"
		butt = new pvWinJ.PVEdit[9];

		butt[0] = new pvWinJ.PVEdit("Main Style");
		butt[1] = new pvWinJ.PVEdit("SubStyle");
		butt[2] = new pvWinJ.PVEdit("Width");

		butt[3] = new pvWinJ.PVEdit("Size");
		butt[4] = new pvWinJ.PVEdit("3D Horizontal");
		butt[5] = new pvWinJ.PVEdit("3D Vertical");

		butt[6] = new pvWinJ.PVEdit("Text Style");
		butt[7] = new pvWinJ.PVEdit("Odometer");
		butt[8] = new pvWinJ.PVEdit("Shadow Style");
		
		for(i=0; i < 9; i++)
		{
			butt[i].setBorder(pvWinJ.PVEdit.RAISED + 2);
			butt[i].setShadow(pvWinJ.PVEdit.RIGHT_BOTTOM);
			butt[i].setShadowWidth(2);
			butt[i].setAlignment(1);
			butt[i].setText3DColor(Color.black);
			butt[i].setFont(new Font("Ariel", Font.BOLD, 12));
			butt[i].setEditable(false);
			add(butt[i]);
			butt[i].setAureole(true);
			butt[i].setBackColor(new Color(0xfff0d000));
			butt[i].setBorderColor(Color.yellow);
			butt[i].setForeground(Color.white);
			butt[i].setBounds(80 + (i / 3) * 155, 70 + (i % 3) * 23, 100, 22);
			//-----------------------------------------
			// allow to process mouse events for butt[]
			butt[i].addMouseListener(new MosListener());
		}
	}

   //-----------------------------------------------
	private void processMouse(boolean press, Object obj)
	{
		//--------------------------------------------
		// process mouseDown/Up events ==>
		// fake edit controls as buttons
		if(!(obj instanceof pvWinJ.PVEdit)) 
			return;
		int i;
		//--------------------------------------------
		// get id of button
		for(i=0; i < 9; i++)
			if(obj == butt[i]) break;
		if(i == 9) 
			return;
		//--------------------------------------------
		// fake border change button
		((pvWinJ.PVEdit)obj).setShadow(press ? 
			pvWinJ.PVEdit.LEFT_TOP : pvWinJ.PVEdit.RIGHT_BOTTOM);
		((pvWinJ.PVEdit)obj).setBorder(2 + 
			(press ? pvWinJ.PVEdit.SUNKEN : pvWinJ.PVEdit.RAISED));
		//--------------------------------------------
		// change property from mouseUp
		if(press)
			return;
		//--------------------------------------------
		int iBuf;
		Dimension d;
		//--------------------------------------------
		// set a property of edit[0] component
		switch(i)
		{
			case 0:
				iBuf = (edit[0].getBorder() & 255) + 10;
				if((iBuf - 1) / 10 > 5) iBuf -= 60;
				edit[0].setBorder(
					(edit[0].getBorder() & 0x00000f00) | iBuf);
				break;
			case 1:
				iBuf = (edit[0].getBorder() & 255) + 1;
				if(iBuf % 10 == 1) iBuf -= 10;
				edit[0].setBorder(
					(edit[0].getBorder() & 0x00000f00) |	iBuf);
				break;
			case 2:
				iBuf = (edit[0].getBorder() & 0x00000f00) >> 8;
				if(++iBuf > 4) iBuf = 0;
				edit[0].setBorder(
						(edit[0].getBorder() & 255) 
						| (iBuf << 8));
				break;
			case 3:
				Font font = edit[0].getFont();
				iBuf = (font.getSize() * 13) / 10;
				if(iBuf > 100) iBuf = 10;
				edit[0].setFont(new Font("Arial", Font.BOLD, iBuf));
				break;
			case 4:
				d = edit[0].getText3D();
				if(++d.width > 3) d.width = -3;
				edit[0].setText3D(d);
				break;
			case 5:
				d = edit[0].getText3D();
				if(++d.height > 3) d.height = -3;
				edit[0].setText3D(d);
				break;
			case 6:
				iBuf = edit[0].getFontStyle() + 1;
				if(iBuf > 4) iBuf = 0;
				edit[0].setFontStyle(iBuf);
				break;
			case 7:
				iBuf = edit[0].getOdometer() + 1;
				if(iBuf > 9) iBuf = 0;
				edit[0].setOdometer(iBuf);
				break;
			case 8:
				iBuf = edit[0].getShadow() + 1;
				if(iBuf > 4) iBuf = 0;
				edit[0].setShadow(iBuf);
				break;
		}
		edit[0].setBounds(5, 140, 560, 110);
	}
	//------------------------------------------
	// handle mouse events
	class MosListener implements MouseListener
	{
		public void mouseClicked(MouseEvent evt) { }
		public void mouseEntered(MouseEvent evt) { }
		public void mouseExited(MouseEvent evt) { }
		public void mousePressed(MouseEvent evt) 
		{ processMouse(true, evt.getSource()); }
		public void mouseReleased(MouseEvent evt) 
		{ processMouse(false, evt.getSource()); }
	}
	//------------------------------------------
	// process text change events
	private void processText(pvWinJ.PVEdit source)
	{
		int i, ii;
		//--------------------------------------------
		// get id of changed edit[] from first 3 id
		for(i=0; i < 3; i++)
			if(source == edit[i]) break;
		//--------------------------------------------
		// set the text of other 2 edit[] to text of modified edit[i]
		if(i < 3)
		{
			for(ii=0; ii < 3; ii++)
				if(ii != i)
					edit[ii].setText(source.getText());
		}
		//--------------------------------------------
		// get id of button
		for(i=3; i < 9; i++)
			if(source == mask[i]) break;
			
		if(i == 9) 
			return;
		//--------------------------------------------
		// set the text of the other mask[] to text of modified mask[i]
		mask[((i & 1) == 1) ? i + 1 : i - 1].setText(source.getText());
	}
	//------------------------------------------
	// handle text change events
	class TxtListener implements TextListener
	{
		public void textValueChanged(TextEvent evt)
		{
			if(evt.getSource() instanceof pvWinJ.PVEdit)
				processText((pvWinJ.PVEdit)evt.getSource());
		}
	}
}
