import java.applet.*;
import java.awt.*;
import java.net.*;
import java.awt.event.*;
import pvWinJ.*;

public class DemoButt extends Applet
{
	pvWinJ.PVButton butt[] = null;
	pvWinJ.PVImageButton imButt[] = null;

	public String getAppletInfo()
	{ return "Name: DemoButt\r\nAuthor: Viktor\r\n"; }
	public void init()
	{
		if(butt != null)
			return;
		setSize(580, 520);
		setBackground(Color.lightGray);
		setLayout(null);
		//-----------------------------------------------
		// add buttons
		butt = new pvWinJ.PVButton[23];

		butt[0] = new pvWinJ.PVButton("Demo applet with PVButton and PVImageButton classes."
			, 16, 0);
		butt[0].setText3D(new Dimension(-1, -1));
		butt[0].setShadow(1);
		butt[0].setEnabled(false);
		add(butt[0]);
		butt[0].setBounds(50, 0, 170, 55);
		butt[0].setAutoResize(true);

		butt[1] = new pvWinJ.PVButton("Buttons support 3-States,", 12, 0);
		butt[1].setText3D(new Dimension(-1, -1));
		add(butt[1]);
		butt[1].setBounds(37, 37, 170, 55);
		butt[1].setAutoResize(true);

		butt[2] = new pvWinJ.PVButton("can Keep Pressed State", 12, 0);
		add(butt[2]);
		butt[2].setText3D(new Dimension(-1, -1));
		butt[2].setBounds(200, 37, 170, 55);
		butt[2].setCanKeepPressed(true);
		butt[2].setAutoResize(true);

		butt[3] = new pvWinJ.PVButton("and display up to 4 images", 12, 0);
		add(butt[3]);
		butt[3].setText3D(new Dimension(-1, -1));
		butt[3].setBounds(353, 37, 85, 35);
		butt[3].setAutoResize(true);

		butt[4] = new pvWinJ.PVButton("Extra popup", 12, PVButton.STANDARD3);
		add(butt[4]);
		butt[4].setMultiLine(true);
		butt[4].setFont(new Font("Courier",  Font.BOLD | Font.ITALIC, 12));
		butt[4].setBackColor(Color.green);
		butt[4].setBounds(10, 65, 50, 45);

		butt[5] = new pvWinJ.PVButton("Multi Line Text", 12, PVButton.STANDARD3);
		add(butt[5]);
		butt[5].setMultiLine(true);
		butt[5].setBackColor(Color.yellow);
		butt[5].setBounds(65, 65, 50, 45);

		butt[6] = new pvWinJ.PVButton("Red", 12, PVButton.STANDARD3);
		add(butt[6]);
		butt[6].setText3DColor(Color.blue);
		butt[6].setFont(new Font("Courier",  Font.ITALIC, 12));
		butt[6].setForeground(Color.white);
		butt[6].setBackColor(Color.red);
		butt[6].setBounds(120, 65, 50, 45);
		int i;
		for(i=1; i < 7; i++)
		{
			if(i > 3)
			{
				butt[i].setTextPressed("OK");
				if(i < 6)
					butt[i].setExtraPoppedUp(true);
			}
			butt[i].setThreeButtonStates(true);
		}
		imButt = new pvWinJ.PVImageButton[12];

		imButt[0] = new pvWinJ.PVImageButton("Home", 11, PVButton.SIMPLE1);
		add(imButt[0]);
		//--------------------------------------
		// load images from file-names using current URL internally
		// Note: the add() should be called before setFileImageAt()
		imButt[0].setFileImageAt("home3.gif", 0);
		imButt[0].setFileImageAt("home2.gif", 1);
		imButt[0].setFileImageAt("home1.gif", 2);
		imButt[0].setAlignment(PVImageButton.TOP);
		imButt[0].setBounds(175, 65, 50, 45);

		imButt[1] = new pvWinJ.PVImageButton("Save", 11, PVButton.SIMPLE1);
		add(imButt[1]);
		imButt[1].setAlignment(PVImageButton.TOP);
		imButt[1].setBounds(230, 65, 50, 45);
		//--------------------------------------
		// load images from file-names using current URL explicitly
		MediaTracker tracker = new MediaTracker(this);
		URL doca = getDocumentBase();
		Image image[] = new Image[3];
		try
		{
			image[0] = getImage(doca, "disk2.gif");
			image[1] = getImage(doca, "disk3.gif");
			image[2] = getImage(doca, "disk1.gif");
			for(i=0; i < 3; i++) tracker.addImage(image[i], i);
			//----------------------------------
			// wait until images are loading.
			try { tracker.waitForAll(); }
			catch(InterruptedException ie) {}
		} catch(Exception e) {}
		for(i=0; i < 3; i++) imButt[1].setImageAt(image[i], i);


		imButt[2] = new pvWinJ.PVImageButton("Stop", 10, PVButton.SIMPLE1);
		add(imButt[2]);
		try
		{
			image[0] = getImage(doca, "stop2.gif");
			image[1] = getImage(doca, "stop3.gif");
			image[2] = getImage(doca, "stop1.gif");
			for(i=0; i < 3; i++) tracker.addImage(image[i], i);
			//----------------------------------
			// wait until images are loading.
			try { tracker.waitForAll(); }
			catch(InterruptedException ie) {}
		} catch(Exception e) {}
		for(i=0; i < 3; i++) imButt[2].setImageAt(image[i], i);

		imButt[2].setExtraPoppedUp(true);
		imButt[2].setAlignment(PVImageButton.TOP);
		imButt[2].setBounds(285, 65, 50, 45);

		imButt[3] = new pvWinJ.PVImageButton("Destroy", 10, PVButton.VAGUE);
		//---------------------------------------------
		// this set of border lines:
		// three sharp raised steps (0...7...1)
		imButt[3].setBorderLines(07474714141);
		add(imButt[3]);
		try
		{
			image[0] = getImage(doca, "exit1.gif");
			image[1] = getImage(doca, "exit2.gif");
			for(i=0; i < 2; i++) tracker.addImage(image[i], i);
			//----------------------------------
			// wait until images are loading.
			try { tracker.waitForAll(); }
			catch(InterruptedException ie) {}
		} catch(Exception e) {}
		for(i=0; i < 2; i++) imButt[3].setImageAt(image[i], i);

		imButt[3].setAlignment(PVImageButton.TOP);
		imButt[3].setBounds(340, 65, 50, 45);

		imButt[4] = new pvWinJ.PVImageButton("");
		imButt[4].setBorderLines(012357337531);
		add(imButt[4]);
		imButt[4].setFileImageAt("plus.gif", 0);
		imButt[4].setFileImageAt("minus.gif", 1);
		imButt[4].setAlignment(PVImageButton.CENTER);
		imButt[4].setBounds(395, 65, 50, 45);

		imButt[5] = new pvWinJ.PVImageButton("");
		//---------------------------------------------
		// this set of border lines:
		// raised border with dark line around (0...1...1)
		imButt[5].setBorderLines(06753132211);
		add(imButt[5]);
		imButt[5].setFileImageAt("cube.gif", 0);
		imButt[5].setFileImageAt("cube2.gif", 1);
		imButt[5].setAlignment(PVImageButton.CENTER);
		imButt[5].setBounds(450, 65, 50, 45);

		imButt[6] = new pvWinJ.PVImageButton("");
		imButt[6].setBorderLines(023457237531);
		add(imButt[6]);
		imButt[6].setFileImageAt("face.gif", 0);
		imButt[6].setFileImageAt("face2.gif", 1);
		imButt[6].setAlignment(PVImageButton.BOTTOM);
		imButt[6].setBounds(505, 65, 50, 45);

		for(i=0; i < 7; i++)
		{
			if(i < 3) 
			{
				imButt[i].setFont(new Font("Courier", Font.PLAIN, 12));
				imButt[i].setThreeButtonStates(true);
			}
			imButt[i].setCanKeepPressed(true);
		}

		Image     im1 = createImage(265, 25);
		Graphics  gr1 = im1.getGraphics();
		gr1.setColor(Color.white);
		gr1.fillRect(0, 0, 266, 26);
		for(i=0; i < 10; i++)
		{
			switch(i % 3)
			{
				case 0: gr1.setColor(Color.green); break;
				case 1: gr1.setColor(Color.yellow); break;
				case 2: gr1.setColor(Color.cyan); break;
			}
			gr1.fillOval(i * 25, 0, 40, 25);
		}
		Image     im2 = createImage(265, 25);
		Graphics  gr2 = im2.getGraphics();
		gr2.setColor(Color.white);
		gr2.fillRect(0, 0, 266, 26);
		for(i=0; i < 10; i++)
		{
			switch(i % 3)
			{
				case 0: gr2.setColor(Color.green); break;
				case 1: gr2.setColor(Color.yellow); break;
				case 2: gr2.setColor(Color.cyan); break;
			}
			gr2.fillOval(10 + i * 25, 0, 18, 25);
		}
		Image     im3 = createImage(50, 50);
		Graphics  gr3 = im3.getGraphics();
		gr3.setColor(Color.lightGray);
		gr3.fillRect(0, 0, 55, 55);
		gr3.setColor(Color.blue);
		gr3.fillOval(0, 2, 46, 45);

		imButt[7] = new pvWinJ.PVImageButton("Images can be created on the run");
		add(imButt[7]);
		imButt[7].setImageAt(im2, 0);
		imButt[7].setImageAt(im1, 1);
		imButt[7].setImageAt(im1, 2);

		imButt[7].setFont(new Font("Arial",  Font.PLAIN, 25));
		imButt[7].setShadow(1);
		imButt[7].setAlignment(PVImageButton.CENTER);
		imButt[7].setText3DColor(Color.red);
		imButt[7].setText3D(new Dimension(1, 0));
		imButt[7].setBackColor(Color.white);
		imButt[7].setCanKeepPressed(true);
		imButt[7].setBounds(10, 145, 400, 45);

		imButt[8] = new pvWinJ.PVImageButton("Images can be loaded from files", 12, PVButton.STANDARD2);
		add(imButt[8]);
		try
		{
			image[0] = getImage(doca, "earth2.gif");
			image[1] = getImage(doca, "earth1.gif");
			image[2] = getImage(doca, "earth3.gif");
			for(i=0; i < 3; i++) tracker.addImage(image[i], i);
			//----------------------------------
			// wait until images are loading.
			try { tracker.waitForAll(); }
			catch(InterruptedException ie) {}
		} catch(Exception e) {}
		for(i=0; i < 3; i++) imButt[8].setImageAt(image[i], i);

		imButt[8].setAureole(true);
		imButt[8].setBounds(10, 195, 220, 50);

		imButt[9] = new pvWinJ.PVImageButton("Here used both methods", 13, PVButton.STANDARD1);
		add(imButt[9]);
		imButt[9].setImageAt(im3, 2);
		imButt[9].setImageAt(image[1], 0);

		imButt[9].setMultiLine(true);
		imButt[9].setText3D(new Dimension(-1, -1));
		imButt[9].setAlignment(PVImageButton.RIGHT);
		imButt[9].setExtraPoppedUp(true);
		imButt[9].setCanKeepPressed(true);
		imButt[9].setBounds(235, 195, 175, 50);

		for(i=7; i < 10; i++)
			imButt[i].setThreeButtonStates(true);

		imButt[10] = new pvWinJ.PVImageButton("AutoResized");
		//---------------------------------------------
		// this set of border lines:
		// three sharp raised steps (0...47...41)
		// and each line is repeated by 4 times (03.....)
		imButt[10].setBorderLines(037474714141);
		add(imButt[10]);

		for(i=0; i < 2; i++) imButt[10].setImageAt(image[i], i);

		imButt[10].setShadow(4);
		imButt[10].setText3D(new Dimension(-1, 0));
		imButt[10].setAlignment(PVImageButton.BOTTOM);
		imButt[10].setBounds(425, 145, 145, 130);
		imButt[10].setAutoResize(true);

		butt[9] = new pvWinJ.PVButton("Different border styles and shadows", 14, 0);
		add(butt[9]);
		butt[9].setText3D(new Dimension(-1, 0));
		butt[9].setBounds(10, 420, 270, 25);
		butt[9].setShadow(1);
		butt[9].setShadowWidth(3);
		butt[9].setAutoResize(true);

		butt[10] = new pvWinJ.PVButton("SIMPLE1", 12, PVButton.SIMPLE1);
		add(butt[10]);
		butt[10].setSwitchColorsOnPress(true);
		butt[10].setShadow(1);
		butt[10].setShadowWidth(10);
		butt[10].setBounds(10, 448, 85, 35);

		butt[11] = new pvWinJ.PVButton("VAGUE", 12, PVButton.VAGUE);
		add(butt[11]);
		butt[11].setForeground(Color.yellow);
		butt[11].setText3DColor(Color.black);
		butt[11].setAureole(true);
		butt[11].setSwitchColorsOnPress(true);
		butt[11].setShadow(2);
		butt[11].setShadowColor(Color.green);
		butt[11].setBounds(100, 448, 85, 35);

		butt[12] = new pvWinJ.PVButton("DOUBLE", 12, PVButton.DOUBLE);
		add(butt[12]);
		butt[12].setAureole(true);
		butt[12].setSwitchColorsOnPress(true);
		butt[12].setShadow(4);
		butt[12].setShadowColor(Color.black);
		butt[12].setBounds(190, 448, 85, 35);

		butt[13] = new pvWinJ.PVButton("Switched Shadow & Colors on Press", 14, 0);
		add(butt[13]);
		butt[13].setText3D(new Dimension(0, -1));
		butt[13].setShadow(1);
		butt[13].setShadowWidth(3);
		butt[13].setBounds(308, 420, 170, 55);
		butt[13].setAutoResize(true);

		butt[14] = new pvWinJ.PVButton("OK", 20, PVButton.STANDARD1);
		add(butt[14]);
		butt[14].setShadowWidth(2);
		butt[14].setText3D(new Dimension(2, 0));
		butt[14].setShadow(1);
		butt[14].setShadowColor(Color.yellow);
		butt[14].setBounds(305, 448, 85, 35);

		butt[15] = new pvWinJ.PVButton("Aureole", 12, PVButton.NONE);
		add(butt[15]);
		butt[15].setAureole(true);
		butt[15].setBackColor(Color.blue);
		butt[15].setShadow(2);
		butt[15].setShadowColor(Color.yellow);
		butt[15].setBounds(395, 448, 85, 35);

		butt[16] = new pvWinJ.PVButton("?", 15, PVButton.SIMPLE2);
		add(butt[16]);
		butt[16].setAureole(true);
		butt[16].setTextPressed("PVButton");
		butt[16].setShadow(4);
		butt[16].setBounds(485, 448, 85, 35);
		for(i=13; i < 17; i++)
		{
			butt[i].setSwitchColorsOnPress(true);
			butt[i].setSwitchShadowOnPress(true);
		}

		butt[7] = new pvWinJ.PVButton("Button state can be set from code", 14, 0);
		butt[7].setText3D(new Dimension(-1, -1));
		butt[7].setEnabled(false);
		butt[7].setBackColor(new Color(0xff80d080));
		butt[7].setThreeButtonStates(false);
		add(butt[7]);
		butt[7].setBounds(0, 285, 85, 35);
		butt[7].setAutoResize(true);

		butt[17] = new pvWinJ.PVButton("Button can be Disabled", 14, PVButton.SIMPLE1);
		add(butt[17]);
		butt[17].setText3D(new Dimension(1, 1));
		butt[17].setEnabled(false);
		butt[17].setBounds(260, 285, 50, 30);
		butt[17].setAutoResize(true);

		butt[8] = new pvWinJ.PVButton("Focus Rectangle");
		add(butt[8]);
		butt[8].setTextPressed("Use Enter/Esc");
		butt[8].setFocusRect(true);
		butt[8].setBounds(237, 330, 115, 32);

		butt[18] = new pvWinJ.PVButton("AutoResized", 9, PVButton.SIMPLE3);
		add(butt[18]);
		butt[18].setBackColor(Color.yellow);
		butt[18].setShadow(1);
		butt[18].setBounds(460, 285, 115, 25);
		butt[18].setAutoResize(true);

		butt[19] = new pvWinJ.PVButton("AutoResized");
		add(butt[19]);
		butt[19].setText3D(new Dimension(-2, -1));
		butt[19].setFont(new Font("Courier", Font.BOLD | Font.ITALIC, 30));
		butt[19].setText3DColor(Color.green);
		butt[19].setForeground(new Color(0xffa06000));
		butt[19].setBounds(360, 323, 105, 35);
		butt[19].setAutoResize(true);

		butt[20] = new pvWinJ.PVButton("Trigger Destination STATE");
		add(butt[20]);
		butt[20].setText3D(new Dimension(-1, -1));
		butt[20].setBounds(10, 320, 220, 25);
		butt[20].addActionListener(new ButtListener());

		butt[21] = new pvWinJ.PVButton("Destination PoppedUp");
		add(butt[21]);
		butt[21].setTextPressed("Destination Pressed");
		butt[21].setText3D(new Dimension(-1, -1));
		butt[21].setBounds(10, 347, 220, 25);

		butt[22] = new pvWinJ.PVButton("Button's appearance and behavior "+
		"can be easily specified by setting its properties.", 14, 0);
		add(butt[22]);
		butt[22].setFont(new Font("Arial", Font.PLAIN, 14));
		butt[22].setAureole(true);
		butt[22].setText3DColor(Color.green);
		butt[22].setBounds(5, 500, 85, 35);
		butt[22].setAutoResize(true);

		for(i=8; i < 23; i++)
			if(i != 16)
				butt[i].setThreeButtonStates(false);

	}
	public void paint(Graphics g)
	{
		g.setColor(Color.white);
		g.drawLine(5, 119, 570, 119);
		g.drawLine(5, 264, 570, 264);
		g.drawLine(5, 389, 570, 389);
		g.setColor(Color.gray);
		g.drawLine(4, 123, 571, 123);
		g.drawLine(4, 268, 571, 268);
		g.drawLine(4, 393, 571, 393);
		g.setColor(Color.darkGray);
		g.drawLine(5, 124, 570, 124);
		g.drawLine(5, 269, 570, 269);
		g.drawLine(5, 394, 570, 394);
	}

	//------------------------------------------
	// handle mouse events
	class ButtListener implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			if(evt.getSource() != butt[20])
				return;
			butt[21].setPressed(!(butt[21].getPressed()));
			return;
		}
	}
}
